Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 403)
+++ doc/groups.dox	(revision 432)
@@ -58,4 +58,77 @@
 
 <b>See also:</b> \ref graph_concepts "Graph Structure Concepts".
+*/
+
+/**
+@defgroup graph_adaptors Adaptor Classes for graphs
+@ingroup graphs
+\brief This group contains several adaptor classes for digraphs and graphs
+
+The main parts of LEMON are the different graph structures, generic
+graph algorithms, graph concepts which couple these, and graph
+adaptors. While the previous notions are more or less clear, the
+latter one needs further explanation. Graph adaptors are graph classes
+which serve for considering graph structures in different ways.
+
+A short example makes this much clearer.  Suppose that we have an
+instance \c g of a directed graph type say ListDigraph and an algorithm
+\code
+template <typename Digraph>
+int algorithm(const Digraph&);
+\endcode
+is needed to run on the reverse oriented graph.  It may be expensive
+(in time or in memory usage) to copy \c g with the reversed
+arcs.  In this case, an adaptor class is used, which (according
+to LEMON digraph concepts) works as a digraph.  The adaptor uses the
+original digraph structure and digraph operations when methods of the
+reversed oriented graph are called.  This means that the adaptor have
+minor memory usage, and do not perform sophisticated algorithmic
+actions.  The purpose of it is to give a tool for the cases when a
+graph have to be used in a specific alteration.  If this alteration is
+obtained by a usual construction like filtering the arc-set or
+considering a new orientation, then an adaptor is worthwhile to use.
+To come back to the reverse oriented graph, in this situation
+\code
+template<typename Digraph> class ReverseDigraph;
+\endcode
+template class can be used. The code looks as follows
+\code
+ListDigraph g;
+ReverseDigraph<ListGraph> rg(g);
+int result = algorithm(rg);
+\endcode
+After running the algorithm, the original graph \c g is untouched.
+This techniques gives rise to an elegant code, and based on stable
+graph adaptors, complex algorithms can be implemented easily.
+
+In flow, circulation and bipartite matching problems, the residual
+graph is of particular importance. Combining an adaptor implementing
+this, shortest path algorithms and minimum mean cycle algorithms,
+a range of weighted and cardinality optimization algorithms can be
+obtained. For other examples, the interested user is referred to the
+detailed documentation of particular adaptors.
+
+The behavior of graph adaptors can be very different. Some of them keep
+capabilities of the original graph while in other cases this would be
+meaningless. This means that the concepts that they are models of depend
+on the graph adaptor, and the wrapped graph(s).
+If an arc of \c rg is deleted, this is carried out by deleting the
+corresponding arc of \c g, thus the adaptor modifies the original graph.
+
+But for a residual graph, this operation has no sense.
+Let us stand one more example here to simplify your work.
+RevGraphAdaptor has constructor
+\code
+ReverseDigraph(Digraph& digraph);
+\endcode
+This means that in a situation, when a <tt>const ListDigraph&</tt>
+reference to a graph is given, then it have to be instantiated with
+<tt>Digraph=const ListDigraph</tt>.
+\code
+int algorithm1(const ListDigraph& g) {
+  RevGraphAdaptor<const ListDigraph> rg(g);
+  return algorithm2(rg);
+}
+\endcode
 */
 
Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 430)
+++ lemon/Makefile.am	(revision 432)
@@ -17,4 +17,5 @@
 
 lemon_HEADERS += \
+	lemon/adaptors.h \
         lemon/arg_parser.h \
 	lemon/assert.h \
Index: lemon/bits/graph_adaptor_extender.h
===================================================================
--- lemon/bits/graph_adaptor_extender.h	(revision 430)
+++ lemon/bits/graph_adaptor_extender.h	(revision 432)
@@ -1,5 +1,5 @@
-/* -*- C++ -*-
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
  *
- * This file is a part of LEMON, a generic C++ optimization library
+ * This file is a part of LEMON, a generic C++ optimization library.
  *
  * Copyright (C) 2003-2008
@@ -25,13 +25,6 @@
 #include <lemon/bits/default_map.h>
 
-
-///\ingroup digraphbits
-///\file
-///\brief Extenders for the digraph adaptor types
 namespace lemon {
 
-  /// \ingroup digraphbits
-  ///
-  /// \brief Extender for the DigraphAdaptors
   template <typename _Digraph>
   class DigraphAdaptorExtender : public _Digraph {
@@ -65,12 +58,12 @@
     Node oppositeNode(const Node &n, const Arc &e) const {
       if (n == Parent::source(e))
-	return Parent::target(e);
+        return Parent::target(e);
       else if(n==Parent::target(e))
-	return Parent::source(e);
+        return Parent::source(e);
       else
-	return INVALID;
-    }
-
-    class NodeIt : public Node { 
+        return INVALID;
+    }
+
+    class NodeIt : public Node {
       const Adaptor* _adaptor;
     public:
@@ -81,19 +74,19 @@
 
       explicit NodeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Node&>(*this));
-      }
-
-      NodeIt(const Adaptor& adaptor, const Node& node) 
-	: Node(node), _adaptor(&adaptor) {}
-
-      NodeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class ArcIt : public Arc { 
+        _adaptor->first(static_cast<Node&>(*this));
+      }
+
+      NodeIt(const Adaptor& adaptor, const Node& node)
+        : Node(node), _adaptor(&adaptor) {}
+
+      NodeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class ArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -104,19 +97,19 @@
 
       explicit ArcIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Arc&>(*this));
-      }
-
-      ArcIt(const Adaptor& adaptor, const Arc& e) : 
-	Arc(e), _adaptor(&adaptor) { }
-
-      ArcIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class OutArcIt : public Arc { 
+        _adaptor->first(static_cast<Arc&>(*this));
+      }
+
+      ArcIt(const Adaptor& adaptor, const Arc& e) :
+        Arc(e), _adaptor(&adaptor) { }
+
+      ArcIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class OutArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -126,21 +119,21 @@
       OutArcIt(Invalid i) : Arc(i) { }
 
-      OutArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstOut(*this, node);
-      }
-
-      OutArcIt(const Adaptor& adaptor, const Arc& arc) 
-	: Arc(arc), _adaptor(&adaptor) {}
-
-      OutArcIt& operator++() { 
-	_adaptor->nextOut(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class InArcIt : public Arc { 
+      OutArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstOut(*this, node);
+      }
+
+      OutArcIt(const Adaptor& adaptor, const Arc& arc)
+        : Arc(arc), _adaptor(&adaptor) {}
+
+      OutArcIt& operator++() {
+        _adaptor->nextOut(*this);
+        return *this;
+      }
+
+    };
+
+
+    class InArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -150,43 +143,29 @@
       InArcIt(Invalid i) : Arc(i) { }
 
-      InArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstIn(*this, node);
-      }
-
-      InArcIt(const Adaptor& adaptor, const Arc& arc) : 
-	Arc(arc), _adaptor(&adaptor) {}
-
-      InArcIt& operator++() { 
-	_adaptor->nextIn(*this);
-	return *this; 
-      }
-
-    };
-
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the source in this case) of the iterator
+      InArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstIn(*this, node);
+      }
+
+      InArcIt(const Adaptor& adaptor, const Arc& arc) :
+        Arc(arc), _adaptor(&adaptor) {}
+
+      InArcIt& operator++() {
+        _adaptor->nextIn(*this);
+        return *this;
+      }
+
+    };
+
     Node baseNode(const OutArcIt &e) const {
       return Parent::source(e);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the target in this case) of the
-    /// iterator
     Node runningNode(const OutArcIt &e) const {
       return Parent::target(e);
     }
 
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the target in this case) of the iterator
     Node baseNode(const InArcIt &e) const {
       return Parent::target(e);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the source in this case) of the
-    /// iterator
     Node runningNode(const InArcIt &e) const {
       return Parent::source(e);
@@ -199,8 +178,8 @@
   ///
   /// \brief Extender for the GraphAdaptors
-  template <typename _Graph> 
+  template <typename _Graph>
   class GraphAdaptorExtender : public _Graph {
   public:
-    
+
     typedef _Graph Parent;
     typedef _Graph Graph;
@@ -211,5 +190,5 @@
     typedef typename Parent::Edge Edge;
 
-    // Graph extension    
+    // Graph extension
 
     int maxId(Node) const {
@@ -239,9 +218,9 @@
     Node oppositeNode(const Node &n, const Edge &e) const {
       if( n == Parent::u(e))
-	return Parent::v(e);
+        return Parent::v(e);
       else if( n == Parent::v(e))
-	return Parent::u(e);
+        return Parent::u(e);
       else
-	return INVALID;
+        return INVALID;
     }
 
@@ -256,5 +235,5 @@
 
 
-    class NodeIt : public Node { 
+    class NodeIt : public Node {
       const Adaptor* _adaptor;
     public:
@@ -265,19 +244,19 @@
 
       explicit NodeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Node&>(*this));
-      }
-
-      NodeIt(const Adaptor& adaptor, const Node& node) 
-	: Node(node), _adaptor(&adaptor) {}
-
-      NodeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class ArcIt : public Arc { 
+        _adaptor->first(static_cast<Node&>(*this));
+      }
+
+      NodeIt(const Adaptor& adaptor, const Node& node)
+        : Node(node), _adaptor(&adaptor) {}
+
+      NodeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class ArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -288,19 +267,19 @@
 
       explicit ArcIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Arc&>(*this));
-      }
-
-      ArcIt(const Adaptor& adaptor, const Arc& e) : 
-	Arc(e), _adaptor(&adaptor) { }
-
-      ArcIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class OutArcIt : public Arc { 
+        _adaptor->first(static_cast<Arc&>(*this));
+      }
+
+      ArcIt(const Adaptor& adaptor, const Arc& e) :
+        Arc(e), _adaptor(&adaptor) { }
+
+      ArcIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+
+    class OutArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -310,21 +289,21 @@
       OutArcIt(Invalid i) : Arc(i) { }
 
-      OutArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstOut(*this, node);
-      }
-
-      OutArcIt(const Adaptor& adaptor, const Arc& arc) 
-	: Arc(arc), _adaptor(&adaptor) {}
-
-      OutArcIt& operator++() { 
-	_adaptor->nextOut(*this);
-	return *this; 
-      }
-
-    };
-
-
-    class InArcIt : public Arc { 
+      OutArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstOut(*this, node);
+      }
+
+      OutArcIt(const Adaptor& adaptor, const Arc& arc)
+        : Arc(arc), _adaptor(&adaptor) {}
+
+      OutArcIt& operator++() {
+        _adaptor->nextOut(*this);
+        return *this;
+      }
+
+    };
+
+
+    class InArcIt : public Arc {
       const Adaptor* _adaptor;
     public:
@@ -334,20 +313,20 @@
       InArcIt(Invalid i) : Arc(i) { }
 
-      InArcIt(const Adaptor& adaptor, const Node& node) 
-	: _adaptor(&adaptor) {
-	_adaptor->firstIn(*this, node);
-      }
-
-      InArcIt(const Adaptor& adaptor, const Arc& arc) : 
-	Arc(arc), _adaptor(&adaptor) {}
-
-      InArcIt& operator++() { 
-	_adaptor->nextIn(*this);
-	return *this; 
-      }
-
-    };
-
-    class EdgeIt : public Parent::Edge { 
+      InArcIt(const Adaptor& adaptor, const Node& node)
+        : _adaptor(&adaptor) {
+        _adaptor->firstIn(*this, node);
+      }
+
+      InArcIt(const Adaptor& adaptor, const Arc& arc) :
+        Arc(arc), _adaptor(&adaptor) {}
+
+      InArcIt& operator++() {
+        _adaptor->nextIn(*this);
+        return *this;
+      }
+
+    };
+
+    class EdgeIt : public Parent::Edge {
       const Adaptor* _adaptor;
     public:
@@ -358,18 +337,18 @@
 
       explicit EdgeIt(const Adaptor& adaptor) : _adaptor(&adaptor) {
-	_adaptor->first(static_cast<Edge&>(*this));
-      }
-
-      EdgeIt(const Adaptor& adaptor, const Edge& e) : 
-	Edge(e), _adaptor(&adaptor) { }
-
-      EdgeIt& operator++() { 
-	_adaptor->next(*this);
-	return *this; 
-      }
-
-    };
-
-    class IncEdgeIt : public Edge { 
+        _adaptor->first(static_cast<Edge&>(*this));
+      }
+
+      EdgeIt(const Adaptor& adaptor, const Edge& e) :
+        Edge(e), _adaptor(&adaptor) { }
+
+      EdgeIt& operator++() {
+        _adaptor->next(*this);
+        return *this;
+      }
+
+    };
+
+    class IncEdgeIt : public Edge {
       friend class GraphAdaptorExtender;
       const Adaptor* _adaptor;
@@ -382,55 +361,35 @@
 
       IncEdgeIt(const Adaptor& adaptor, const Node &n) : _adaptor(&adaptor) {
-	_adaptor->firstInc(static_cast<Edge&>(*this), direction, n);
+        _adaptor->firstInc(static_cast<Edge&>(*this), direction, n);
       }
 
       IncEdgeIt(const Adaptor& adaptor, const Edge &e, const Node &n)
-	: _adaptor(&adaptor), Edge(e) {
-	direction = (_adaptor->u(e) == n);
+        : _adaptor(&adaptor), Edge(e) {
+        direction = (_adaptor->u(e) == n);
       }
 
       IncEdgeIt& operator++() {
-	_adaptor->nextInc(*this, direction);
-	return *this; 
-      }
-    };
-
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the source in this case) of the iterator
+        _adaptor->nextInc(*this, direction);
+        return *this;
+      }
+    };
+
     Node baseNode(const OutArcIt &a) const {
       return Parent::source(a);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the target in this case) of the
-    /// iterator
     Node runningNode(const OutArcIt &a) const {
       return Parent::target(a);
     }
 
-    /// \brief Base node of the iterator
-    ///
-    /// Returns the base node (ie. the target in this case) of the iterator
     Node baseNode(const InArcIt &a) const {
       return Parent::target(a);
     }
-    /// \brief Running node of the iterator
-    ///
-    /// Returns the running node (ie. the source in this case) of the
-    /// iterator
     Node runningNode(const InArcIt &a) const {
       return Parent::source(a);
     }
 
-    /// Base node of the iterator
-    ///
-    /// Returns the base node of the iterator
     Node baseNode(const IncEdgeIt &e) const {
       return e.direction ? Parent::u(e) : Parent::v(e);
     }
-    /// Running node of the iterator
-    ///
-    /// Returns the running node of the iterator
     Node runningNode(const IncEdgeIt &e) const {
       return e.direction ? Parent::v(e) : Parent::u(e);
Index: lemon/bits/variant.h
===================================================================
--- lemon/bits/variant.h	(revision 430)
+++ lemon/bits/variant.h	(revision 432)
@@ -1,5 +1,5 @@
-/* -*- C++ -*-
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
  *
- * This file is a part of LEMON, a generic C++ optimization library
+ * This file is a part of LEMON, a generic C++ optimization library.
  *
  * Copyright (C) 2003-2008
@@ -28,5 +28,5 @@
 
   namespace _variant_bits {
-  
+
     template <int left, int right>
     struct CTMax {
@@ -87,7 +87,7 @@
       flag = bivariant.flag;
       if (flag) {
-        new(reinterpret_cast<First*>(data)) First(bivariant.first());      
+        new(reinterpret_cast<First*>(data)) First(bivariant.first());
       } else {
-        new(reinterpret_cast<Second*>(data)) Second(bivariant.second());      
+        new(reinterpret_cast<Second*>(data)) Second(bivariant.second());
       }
     }
@@ -107,5 +107,5 @@
       destroy();
       flag = true;
-      new(reinterpret_cast<First*>(data)) First();   
+      new(reinterpret_cast<First*>(data)) First();
       return *this;
     }
@@ -118,5 +118,5 @@
       destroy();
       flag = true;
-      new(reinterpret_cast<First*>(data)) First(f);   
+      new(reinterpret_cast<First*>(data)) First(f);
       return *this;
     }
@@ -129,5 +129,5 @@
       destroy();
       flag = false;
-      new(reinterpret_cast<Second*>(data)) Second();   
+      new(reinterpret_cast<Second*>(data)) Second();
       return *this;
     }
@@ -140,5 +140,5 @@
       destroy();
       flag = false;
-      new(reinterpret_cast<Second*>(data)) Second(s);   
+      new(reinterpret_cast<Second*>(data)) Second(s);
       return *this;
     }
@@ -160,7 +160,7 @@
       flag = bivariant.flag;
       if (flag) {
-        new(reinterpret_cast<First*>(data)) First(bivariant.first());      
+        new(reinterpret_cast<First*>(data)) First(bivariant.first());
       } else {
-        new(reinterpret_cast<Second*>(data)) Second(bivariant.second());      
+        new(reinterpret_cast<Second*>(data)) Second(bivariant.second());
       }
       return *this;
@@ -232,5 +232,5 @@
       }
     }
-    
+
     char data[_variant_bits::CTMax<sizeof(First), sizeof(Second)>::value];
     bool flag;
@@ -238,5 +238,5 @@
 
   namespace _variant_bits {
-    
+
     template <int _idx, typename _TypeMap>
     struct Memory {
@@ -277,6 +277,6 @@
     template <int _idx, typename _TypeMap>
     struct Size {
-      static const int value = 
-      CTMax<sizeof(typename _TypeMap::template Map<_idx>::Type), 
+      static const int value =
+      CTMax<sizeof(typename _TypeMap::template Map<_idx>::Type),
             Size<_idx - 1, _TypeMap>::value>::value;
     };
@@ -284,5 +284,5 @@
     template <typename _TypeMap>
     struct Size<0, _TypeMap> {
-      static const int value = 
+      static const int value =
       sizeof(typename _TypeMap::template Map<0>::Type);
     };
@@ -302,5 +302,5 @@
   /// variant type.
   /// \param _TypeMap This class describes the types of the Variant. The
-  /// _TypeMap::Map<index>::Type should be a valid type for each index 
+  /// _TypeMap::Map<index>::Type should be a valid type for each index
   /// in the range {0, 1, ..., _num - 1}. The \c VariantTypeMap is helper
   /// class to define such type mappings up to 10 types.
@@ -338,5 +338,5 @@
     Variant() {
       flag = 0;
-      new(reinterpret_cast<typename TypeMap::template Map<0>::Type*>(data)) 
+      new(reinterpret_cast<typename TypeMap::template Map<0>::Type*>(data))
         typename TypeMap::template Map<0>::Type();
     }
@@ -379,5 +379,5 @@
       _variant_bits::Memory<num - 1, TypeMap>::destroy(flag, data);
       flag = _idx;
-      new(reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>(data)) 
+      new(reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>(data))
         typename TypeMap::template Map<_idx>::Type();
       return *this;
@@ -392,5 +392,5 @@
       _variant_bits::Memory<num - 1, TypeMap>::destroy(flag, data);
       flag = _idx;
-      new(reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>(data)) 
+      new(reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>(data))
         typename TypeMap::template Map<_idx>::Type(init);
       return *this;
@@ -404,5 +404,5 @@
       LEMON_DEBUG(_idx == flag, "Variant wrong index");
       return *reinterpret_cast<const typename TypeMap::
-        template Map<_idx>::Type*>(data); 
+        template Map<_idx>::Type*>(data);
     }
 
@@ -414,5 +414,5 @@
       LEMON_DEBUG(_idx == flag, "Variant wrong index");
       return *reinterpret_cast<typename TypeMap::template Map<_idx>::Type*>
-        (data); 
+        (data);
     }
 
@@ -425,5 +425,5 @@
 
   private:
-    
+
     char data[_variant_bits::Size<num - 1, TypeMap>::value];
     int flag;
@@ -443,5 +443,5 @@
 
     struct List {};
-    
+
     template <typename _Type, typename _List>
     struct Insert {
@@ -450,5 +450,5 @@
     };
 
-    template <int _idx, typename _T0, typename _T1, typename _T2, 
+    template <int _idx, typename _T0, typename _T1, typename _T2,
               typename _T3, typename _T5, typename _T4, typename _T6,
               typename _T7, typename _T8, typename _T9>
@@ -467,5 +467,5 @@
       typedef typename Get<_idx, L0>::Type Type;
     };
-    
+
   }
 
@@ -476,5 +476,5 @@
   /// \see Variant
   template <
-    typename _T0, 
+    typename _T0,
     typename _T1 = void, typename _T2 = void, typename _T3 = void,
     typename _T5 = void, typename _T4 = void, typename _T6 = void,
@@ -488,5 +488,5 @@
     };
   };
-  
+
 }
 
Index: test/graph_adaptor_test.cc
===================================================================
--- test/graph_adaptor_test.cc	(revision 431)
+++ test/graph_adaptor_test.cc	(revision 432)
@@ -1,5 +1,5 @@
-/* -*- C++ -*-
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
  *
- * This file is a part of LEMON, a generic C++ optimization library
+ * This file is a part of LEMON, a generic C++ optimization library.
  *
  * Copyright (C) 2003-2008
@@ -26,6 +26,5 @@
 #include<lemon/concepts/graph.h>
 
-#include<lemon/digraph_adaptor.h>
-#include<lemon/graph_adaptor.h>
+#include<lemon/adaptors.h>
 
 #include <limits>
@@ -38,9 +37,9 @@
 using namespace lemon;
 
-void checkRevDigraphAdaptor() {
-  checkConcept<concepts::Digraph, RevDigraphAdaptor<concepts::Digraph> >();
+void checkReverseDigraph() {
+  checkConcept<concepts::Digraph, ReverseDigraph<concepts::Digraph> >();
 
   typedef ListDigraph Digraph;
-  typedef RevDigraphAdaptor<Digraph> Adaptor;
+  typedef ReverseDigraph<Digraph> Adaptor;
 
   Digraph digraph;
@@ -54,5 +53,5 @@
   Digraph::Arc a2 = digraph.addArc(n1, n3);
   Digraph::Arc a3 = digraph.addArc(n2, n3);
-  
+
   checkGraphNodeList(adaptor, 3);
   checkGraphArcList(adaptor, 3);
@@ -79,7 +78,7 @@
 }
 
-void checkSubDigraphAdaptor() {
-  checkConcept<concepts::Digraph, 
-    SubDigraphAdaptor<concepts::Digraph, 
+void checkSubDigraph() {
+  checkConcept<concepts::Digraph,
+    SubDigraph<concepts::Digraph,
     concepts::Digraph::NodeMap<bool>,
     concepts::Digraph::ArcMap<bool> > >();
@@ -88,5 +87,5 @@
   typedef Digraph::NodeMap<bool> NodeFilter;
   typedef Digraph::ArcMap<bool> ArcFilter;
-  typedef SubDigraphAdaptor<Digraph, NodeFilter, ArcFilter> Adaptor;
+  typedef SubDigraph<Digraph, NodeFilter, ArcFilter> Adaptor;
 
   Digraph digraph;
@@ -124,5 +123,5 @@
   checkGraphArcMap(adaptor);
 
-  arc_filter[a2] = false; 
+  arc_filter[a2] = false;
 
   checkGraphNodeList(adaptor, 3);
@@ -144,5 +143,5 @@
   checkGraphArcMap(adaptor);
 
-  node_filter[n1] = false; 
+  node_filter[n1] = false;
 
   checkGraphNodeList(adaptor, 2);
@@ -176,12 +175,12 @@
 }
 
-void checkNodeSubDigraphAdaptor() {
-  checkConcept<concepts::Digraph, 
-    NodeSubDigraphAdaptor<concepts::Digraph, 
+void checkFilterNodes1() {
+  checkConcept<concepts::Digraph,
+    FilterNodes<concepts::Digraph,
       concepts::Digraph::NodeMap<bool> > >();
 
   typedef ListDigraph Digraph;
   typedef Digraph::NodeMap<bool> NodeFilter;
-  typedef NodeSubDigraphAdaptor<Digraph, NodeFilter> Adaptor;
+  typedef FilterNodes<Digraph, NodeFilter> Adaptor;
 
   Digraph digraph;
@@ -217,5 +216,5 @@
   checkGraphArcMap(adaptor);
 
-  node_filter[n1] = false; 
+  node_filter[n1] = false;
 
   checkGraphNodeList(adaptor, 2);
@@ -248,12 +247,12 @@
 }
 
-void checkArcSubDigraphAdaptor() {
-  checkConcept<concepts::Digraph, 
-    ArcSubDigraphAdaptor<concepts::Digraph, 
+void checkFilterArcs() {
+  checkConcept<concepts::Digraph,
+    FilterArcs<concepts::Digraph,
     concepts::Digraph::ArcMap<bool> > >();
 
   typedef ListDigraph Digraph;
   typedef Digraph::ArcMap<bool> ArcFilter;
-  typedef ArcSubDigraphAdaptor<Digraph, ArcFilter> Adaptor;
+  typedef FilterArcs<Digraph, ArcFilter> Adaptor;
 
   Digraph digraph;
@@ -289,5 +288,5 @@
   checkGraphArcMap(adaptor);
 
-  arc_filter[a2] = false; 
+  arc_filter[a2] = false;
 
   checkGraphNodeList(adaptor, 3);
@@ -322,9 +321,9 @@
 }
 
-void checkUndirDigraphAdaptor() {
-  checkConcept<concepts::Graph, UndirDigraphAdaptor<concepts::Digraph> >();
+void checkUndirector() {
+  checkConcept<concepts::Graph, Undirector<concepts::Digraph> >();
 
   typedef ListDigraph Digraph;
-  typedef UndirDigraphAdaptor<Digraph> Adaptor;
+  typedef Undirector<Digraph> Adaptor;
 
   Digraph digraph;
@@ -338,5 +337,5 @@
   Digraph::Arc a2 = digraph.addArc(n1, n3);
   Digraph::Arc a3 = digraph.addArc(n2, n3);
-  
+
   checkGraphNodeList(adaptor, 3);
   checkGraphArcList(adaptor, 6);
@@ -372,13 +371,13 @@
 }
 
-void checkResDigraphAdaptor() {
-  checkConcept<concepts::Digraph, 
-    ResDigraphAdaptor<concepts::Digraph, 
-    concepts::Digraph::ArcMap<int>, 
+void checkResidual() {
+  checkConcept<concepts::Digraph,
+    Residual<concepts::Digraph,
+    concepts::Digraph::ArcMap<int>,
     concepts::Digraph::ArcMap<int> > >();
 
   typedef ListDigraph Digraph;
   typedef Digraph::ArcMap<int> IntArcMap;
-  typedef ResDigraphAdaptor<Digraph, IntArcMap> Adaptor;
+  typedef Residual<Digraph, IntArcMap> Adaptor;
 
   Digraph digraph;
@@ -408,5 +407,5 @@
     flow[a] = 0;
   }
-  
+
   checkGraphNodeList(adaptor, 4);
   checkGraphArcList(adaptor, 6);
@@ -426,5 +425,5 @@
     flow[a] = capacity[a] / 2;
   }
-  
+
   checkGraphNodeList(adaptor, 4);
   checkGraphArcList(adaptor, 12);
@@ -450,5 +449,5 @@
     flow[a] = capacity[a];
   }
-  
+
   checkGraphNodeList(adaptor, 4);
   checkGraphArcList(adaptor, 6);
@@ -471,15 +470,16 @@
   int flow_value = 0;
   while (true) {
-    
+
     Bfs<Adaptor> bfs(adaptor);
     bfs.run(n1, n4);
-    
+
     if (!bfs.reached(n4)) break;
 
     Path<Adaptor> p = bfs.path(n4);
-    
+
     int min = std::numeric_limits<int>::max();
     for (Path<Adaptor>::ArcIt a(p); a != INVALID; ++a) {
-      if (adaptor.rescap(a) < min) min = adaptor.rescap(a);
+      if (adaptor.residualCapacity(a) < min)
+        min = adaptor.residualCapacity(a);
     }
 
@@ -494,9 +494,9 @@
 }
 
-void checkSplitDigraphAdaptor() {
-  checkConcept<concepts::Digraph, SplitDigraphAdaptor<concepts::Digraph> >();
+void checkSplitNodes() {
+  checkConcept<concepts::Digraph, SplitNodes<concepts::Digraph> >();
 
   typedef ListDigraph Digraph;
-  typedef SplitDigraphAdaptor<Digraph> Adaptor;
+  typedef SplitNodes<Digraph> Adaptor;
 
   Digraph digraph;
@@ -510,5 +510,5 @@
   Digraph::Arc a2 = digraph.addArc(n1, n3);
   Digraph::Arc a3 = digraph.addArc(n2, n3);
-  
+
   checkGraphNodeList(adaptor, 6);
   checkGraphArcList(adaptor, 6);
@@ -531,5 +531,5 @@
   checkNodeIds(adaptor);
   checkArcIds(adaptor);
-  
+
   checkGraphNodeMap(adaptor);
   checkGraphArcMap(adaptor);
@@ -538,8 +538,8 @@
     if (adaptor.origArc(a)) {
       Digraph::Arc oa = a;
-      check(adaptor.source(a) == adaptor.outNode(digraph.source(oa)), 
-	    "Wrong split");
-      check(adaptor.target(a) == adaptor.inNode(digraph.target(oa)), 
-	    "Wrong split"); 
+      check(adaptor.source(a) == adaptor.outNode(digraph.source(oa)),
+            "Wrong split");
+      check(adaptor.target(a) == adaptor.inNode(digraph.target(oa)),
+            "Wrong split");
     } else {
       Digraph::Node on = a;
@@ -550,7 +550,7 @@
 }
 
-void checkSubGraphAdaptor() {
-  checkConcept<concepts::Graph, 
-    SubGraphAdaptor<concepts::Graph, 
+void checkSubGraph() {
+  checkConcept<concepts::Graph,
+    SubGraph<concepts::Graph,
     concepts::Graph::NodeMap<bool>,
     concepts::Graph::EdgeMap<bool> > >();
@@ -559,5 +559,5 @@
   typedef Graph::NodeMap<bool> NodeFilter;
   typedef Graph::EdgeMap<bool> EdgeFilter;
-  typedef SubGraphAdaptor<Graph, NodeFilter, EdgeFilter> Adaptor;
+  typedef SubGraph<Graph, NodeFilter, EdgeFilter> Adaptor;
 
   Graph graph;
@@ -608,5 +608,5 @@
   checkGraphEdgeMap(adaptor);
 
-  edge_filter[e2] = false; 
+  edge_filter[e2] = false;
 
   checkGraphNodeList(adaptor, 4);
@@ -639,5 +639,5 @@
   checkGraphEdgeMap(adaptor);
 
-  node_filter[n1] = false; 
+  node_filter[n1] = false;
 
   checkGraphNodeList(adaptor, 3);
@@ -685,12 +685,12 @@
 }
 
-void checkNodeSubGraphAdaptor() {
-  checkConcept<concepts::Graph, 
-    NodeSubGraphAdaptor<concepts::Graph, 
+void checkFilterNodes2() {
+  checkConcept<concepts::Graph,
+    FilterNodes<concepts::Graph,
       concepts::Graph::NodeMap<bool> > >();
 
   typedef ListGraph Graph;
   typedef Graph::NodeMap<bool> NodeFilter;
-  typedef NodeSubGraphAdaptor<Graph, NodeFilter> Adaptor;
+  typedef FilterNodes<Graph, NodeFilter> Adaptor;
 
   Graph graph;
@@ -739,5 +739,5 @@
   checkGraphEdgeMap(adaptor);
 
-  node_filter[n1] = false; 
+  node_filter[n1] = false;
 
   checkGraphNodeList(adaptor, 3);
@@ -784,12 +784,12 @@
 }
 
-void checkEdgeSubGraphAdaptor() {
-  checkConcept<concepts::Graph, 
-    EdgeSubGraphAdaptor<concepts::Graph, 
+void checkFilterEdges() {
+  checkConcept<concepts::Graph,
+    FilterEdges<concepts::Graph,
     concepts::Graph::EdgeMap<bool> > >();
 
   typedef ListGraph Graph;
   typedef Graph::EdgeMap<bool> EdgeFilter;
-  typedef EdgeSubGraphAdaptor<Graph, EdgeFilter> Adaptor;
+  typedef FilterEdges<Graph, EdgeFilter> Adaptor;
 
   Graph graph;
@@ -838,5 +838,5 @@
   checkGraphEdgeMap(adaptor);
 
-  edge_filter[e2] = false; 
+  edge_filter[e2] = false;
 
   checkGraphNodeList(adaptor, 4);
@@ -886,11 +886,11 @@
 }
 
-void checkDirGraphAdaptor() {
-  checkConcept<concepts::Digraph, 
-    DirGraphAdaptor<concepts::Graph, concepts::Graph::EdgeMap<bool> > >();
+void checkOrienter() {
+  checkConcept<concepts::Digraph,
+    Orienter<concepts::Graph, concepts::Graph::EdgeMap<bool> > >();
 
   typedef ListGraph Graph;
   typedef ListGraph::EdgeMap<bool> DirMap;
-  typedef DirGraphAdaptor<Graph> Adaptor;
+  typedef Orienter<Graph> Adaptor;
 
   Graph graph;
@@ -905,14 +905,14 @@
   Graph::Edge e2 = graph.addEdge(n1, n3);
   Graph::Edge e3 = graph.addEdge(n2, n3);
-  
+
   checkGraphNodeList(adaptor, 3);
   checkGraphArcList(adaptor, 3);
   checkGraphConArcList(adaptor, 3);
-  
+
   {
     dir[e1] = true;
     Adaptor::Node u = adaptor.source(e1);
     Adaptor::Node v = adaptor.target(e1);
-    
+
     dir[e1] = false;
     check (u == adaptor.target(e1), "Wrong dir");
@@ -927,5 +927,5 @@
     Adaptor::Node u = adaptor.source(e2);
     Adaptor::Node v = adaptor.target(e2);
-    
+
     dir[e2] = false;
     check (u == adaptor.target(e2), "Wrong dir");
@@ -940,5 +940,5 @@
     Adaptor::Node u = adaptor.source(e3);
     Adaptor::Node v = adaptor.target(e3);
-    
+
     dir[e3] = false;
     check (u == adaptor.target(e3), "Wrong dir");
@@ -968,16 +968,16 @@
 int main(int, const char **) {
 
-  checkRevDigraphAdaptor();
-  checkSubDigraphAdaptor();
-  checkNodeSubDigraphAdaptor();
-  checkArcSubDigraphAdaptor();
-  checkUndirDigraphAdaptor();
-  checkResDigraphAdaptor();
-  checkSplitDigraphAdaptor();
-
-  checkSubGraphAdaptor();
-  checkNodeSubGraphAdaptor();
-  checkEdgeSubGraphAdaptor();
-  checkDirGraphAdaptor();
+  checkReverseDigraph();
+  checkSubDigraph();
+  checkFilterNodes1();
+  checkFilterArcs();
+  checkUndirector();
+  checkResidual();
+  checkSplitNodes();
+
+  checkSubGraph();
+  checkFilterNodes2();
+  checkFilterEdges();
+  checkOrienter();
 
   return 0;
